Attribute VB_Name = "Global"

Option Explicit

Global Const pi = 3.1415927


Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Public Const SW_SHOWNORMAL = 1

Global Warnings As String   'Error messages are stored here.
Global Fatal As String

Type Winding
    Usage As Integer    '0 for primary, 1 for secondary, 2 for isolation
    Turns As Integer
    Layers As Integer
    TpLayer As Integer
    Wires   As Integer  'Number of wires in parallel
    ILThick As Single
    Cap As Single
    L As Single
    R As Single
End Type

Global Fichier As String
Global Windings() As Winding
Global StartSide As Long
Global TbDia(4) As Single
Global TbTurns(4) As Single
Global TbR(4) As Single
Global TbV(4) As Single


Global FeSect As Single
Global FeLen As Single
Global ZRatio As Single
Global LSpMoy As Single
Global Lp As Single
Global LL As Single
Global CS As Single


Global PlotCurrentX As Single   'The last know location of the cursor

Type MuVsB
    Mu As Single
    b As Single
End Type

Dim TbMu() As MuVsB
Global Tmax As Single
Global CoreData As String  'Le nom du fichier

Public Sub FillTbMu()
Dim S As String
Dim T As String
Dim I As Integer
Dim J As Integer

    Tmax = Val(GetIniString(CoreData, "GENERAL", "MaxB"))
    If Tmax = 0 Then Tmax = 1.25
    S = GetKeysInSection(CoreData, "PERM")

    I = 1
    T = Substring(S, I, ",")
    Do While Len(T)
        ReDim Preserve TbMu(J + 1)
        TbMu(J).b = Val(T)
        TbMu(J).Mu = Val(GetIniString(CoreData, "PERM", T))
        I = I + 1
        J = J + 1
        T = Substring(S, I, ",")
    Loop
End Sub

Public Function Extrapol(X As Single) As Single
'Returns Mu from induction (in X) using a lookup table (TbMu).

Dim I As Integer
Dim NX As Single
Dim PX As Single
Dim NY As Single
Dim PY As Single
Dim D As Single

    If X = 0 Then
        Extrapol = 1
        Exit Function
    End If
    D = 1
    For I = LBound(TbMu) To UBound(TbMu)
        If TbMu(I).b >= X Then  'Trouv ou trop loin
            NX = TbMu(I).b
            PX = NX
            NY = TbMu(I).Mu
            PY = NY
            If TbMu(I).b <> X And I > LBound(TbMu) Then   'Il y a un prcdent
                PX = TbMu(I - 1).b
                PY = TbMu(I - 1).Mu
            End If
            D = X - PX
            If D > 0 Then D = D / (NX - PX) 'Linear interpolation
'            D = (1 - Cos(D * pi)) / 2   'Cosine interpolation
'            Debug.Print "D", Format(D, "0.###")
            Extrapol = PY * (1 - D) + NY * D
'            Extrapol = Sqr(PY ^ 2 + PX ^ 2)
'            Extrapol = PY + ((NY - PY) / ((NX - PX) / (X - PX)))   'Another linear interpolation !
            If Extrapol = 0 Then Extrapol = 1   'Never returns 0
            Exit Function   'Ca baigne !
        End If
    Next I
    Extrapol = TbMu(I - 2).Mu 'X trop grand,on renvoie le plafond !
End Function

Public Function Extrapol(X As Single) As Single
'Tentative :
'Returns Mu from induction (in X) using a quadratic function like Mu = ax bx +c
' a, b and c being specific for each core grade and are found (added) in TbMu
'' TODO ''
' To produce a dissymetric curves paste two half quadratic ones with different parameters.
'The paste point is at vertex

Static Core As String
Static A As Single
Static b As Single
Static C As Single
Dim N As Single 'Numerator
Dim D As Single 'Denominator

    If Core <> CoreData Then
        Core = CoreData
        A = Val(GetIniString(CoreData, "ABC", "A"))
        b = Val(GetIniString(CoreData, "ABC", "B"))
        C = Val(GetIniString(CoreData, "ABC", "C"))
    End If
    
'    If X > 3 Then X = 3
'    If X < 0 Then X = 0
    N = (X - b) ^ 2
    D = 2 * C ^ 2
    Extrapol = A * Exp(-N / D)
'    Extrapol = a * X ^ 1.7 + b * X + C
'    If Extrapol < 0 Then Extrapol = 1  ' Force a floor
End Function

Public Function Extrapol(X As Single) As Single
'Tentative :
' Returns Mu from induction using a Gauss curve like Mu = (1/(r * sqr ( 2* pi)( ^ (- 0.5( X - m)r) ^ 2)
' m and r being > 0 values specific for each core grade as found in a table.
'
' lorentz : L(x)= 1/(1+x). top value is 2/pi for x = 0. Here, x will be -X ??
' or (with a "spread" parameter s ):L(x)= 2/(pi r)/1+(x/(r/2))

Static Core As String
Dim X0 As Single
Static C As Single
Static M As Single
Static W As Single
Static T As Single
Static TR As Single
Static TL As Single

Debug.Print X
   
    If Core <> CoreData Then
        Core = CoreData
        C = Val(GetIniString(CoreData, "X", "Center"))
        M = Val(GetIniString(CoreData, "X", "Max"))
        W = Val(GetIniString(CoreData, "X", "Width"))
        T = Val(GetIniString(CoreData, "X", "Tilt"))
        TL = Val(GetIniString(CoreData, "X", "TrimLeft"))
        TR = Val(GetIniString(CoreData, "X", "TrimRight"))

    End If
    X0 = X - C
    X0 = X0 * W
'    If X0 > 0 And T > 0 Then X0 = X0 * T    ' Expand positive values of X0
'    If X0 < 0 And T < 0 Then X0 = X0 * Abs(T)    ' Expand negatives values ot X0
    If X0 > 0 And TR <> 0 Then X0 = X0 ^ TR ' Expand or stretch positive values of X0
'    If X0 < 0 Then X0 = X0 - X0 ^ TL
'    If X0 < 0 And TL <> 0 Then X0 = -Abs(Abs(1 / (0 - X0)) * Abs(TL)) ' Expand or stretch negative values of X0
    

'    Extrapol = M * (4 ^ (-(0.5 * (X0 ^ 2)))) 'Gaussian
'    Extrapol = Extrapol ^ T
    Extrapol = M / (1 + X0 ^ 2) 'Laurentzian
'    Debug.Print X, Extrapol
'    Extrapol = Extrapol * M    'while debugging
End Function
Public Function ShowWindings(IW As Single)  ', Patern As Integer)
' Describe Patern ...
Dim I As Integer
Dim J As Integer
Dim N As Integer
Dim What As String
Dim Term As Integer
Dim W As Integer
Dim LR As Boolean   'Left = false, right = true
Dim Side As String
Dim Done As Integer
    
'    Debug.Print
'    Debug.Print "Step", "What", "Dia/Thick", "Turns", "Done", "Left"
'    LR = True
    For I = 0 To UBound(Windings)
        Windings(I).TpLayer = Windings(I).Turns \ Windings(I).Layers
        If Windings(I).Turns Mod Windings(I).Layers Then Windings(I).TpLayer = Windings(I).TpLayer + 1
        Side = " Right" '" Left"
        If LR Then Side = " Right"
        Select Case Windings(I).Usage
            Case 0, 1
                Term = Term + 1
                What = "Copper"
'                Debug.Print "- - Start a " & Windings(I).Turns & " turns section in " & Windings(I).Layers & " layers - -"
                If Windings(I).Wires > 1 Then
                    For W = 1 To Windings(I).Wires
'                        Debug.Print "Term #" & Term & Chr(&H60 + W) & Side  'Add a letter according to number of wires
                    Next
                Else
'                    Debug.Print "Term #" & Term & Side
                End If
            Case Else
                What = "Paper"
        End Select
        For J = 1 To Windings(I).Layers
            N = N + 1
            LR = Not LR
            Done = J * Windings(I).TpLayer
'            Debug.Print N, What, TbDia(Windings(I).Usage), Windings(I).TpLayer, Done, Windings(I).Turns - Done    'Usage, Windings(I).Turns, Windings(I).Layers, Windings(I).TpLayer
            If Windings(I).ILThick > 0 Then     'Insert it
                N = N + 1
'                Debug.Print N, "Paper", Windings(I).ILThick
            End If
        Next
        Side = " Left"
        If LR Then Side = " Right"
        Select Case Windings(I).Usage
            Case 0, 1
                Term = Term + 1
                What = "Copper"
'                Debug.Print "- - End of the " & Windings(I).Turns & " turns section in " & Windings(I).Layers & " layers - -"
                If Windings(I).Wires > 1 Then
                    For W = 1 To Windings(I).Wires
'                        Debug.Print "Term #" & Term & Chr(&H60 + W) & Side  'Add a letter according to number of wires
                    Next
                Else
'                    Debug.Print "Term #" & Term & Side
                End If
            Case Else
                What = "Paper"
        End Select
        N = N + 1
'        Debug.Print N, "CardBoard", IW
    Next
'    Debug.Print "- - END. Total " & N & " Steps"
End Function
Public Sub AddWarning(Msg As String)

    Warnings = Warnings & Msg & vbCrLf
End Sub
Public Sub SetFatal(Msg As String)
    
    Fatal = Fatal & Msg & vbCrLf
End Sub
Public Sub ShowFatal()

    If Len(Fatal) = 0 Then Exit Sub
    MsgBox Fatal, , "Fatal Error"
    Fatal = ""
End Sub
